package io.provis.assembly.action.artifact;

import io.provis.model.Action;
import io.provis.util.FileCopier;

import java.io.File;

import javax.inject.Named;
import javax.inject.Singleton;

import org.sonatype.aether.artifact.Artifact;

@Singleton
@Named("write")
public class WriteToDiskAction implements Action {
  
  private Artifact artifact;
  private File outputDirectory;
  
  public WriteToDiskAction(Artifact artifact, File outputDirectory) {
    this.artifact = artifact;
    this.outputDirectory = outputDirectory;
  }

  public String getName() {
    return "write";
  }  
  
  public void execute() {
    File file = artifact.getFile();
    if (outputDirectory != null) {
      FileCopier.copy(file, new File(outputDirectory, file.getName()));
    } else {
      FileCopier.copy(file, new File(outputDirectory, file.getName()));
    }
  }
}