package io.provis.assembly.action.fileset;

import io.provis.model.Action;

import java.io.File;
import java.io.IOException;
import java.util.List;

import javax.inject.Named;

import org.codehaus.plexus.util.FileUtils;

@Named("executable")
public class MakeExecutableAction implements Action {

  private String includes;
  private String excludes;
  
  private File fileSetDirectory;
  
  public void execute() {

    if (fileSetDirectory.exists()) {
      try {
        List<File> files = FileUtils.getFiles(fileSetDirectory, includes, excludes);
        for (File file : files) {          
          file.setExecutable(true);
        }
      } catch (IOException e) {
        e.printStackTrace();
      }
    }
  }
}