package io.provis.provision;

import io.provis.model.ProvisioModel;

import java.io.File;
import java.util.List;
import java.util.Map;

import org.sonatype.aether.RepositorySystem;
import org.sonatype.aether.RepositorySystemSession;
import org.sonatype.aether.repository.RemoteRepository;

public class ProvisioningRequest {
  
  private File outputDirectory;
  private String localRepository;
  private List<RemoteRepository> remoteRepositories;
  private RepositorySystem repositorySystem;
  private RepositorySystemSession repositorySystemSession;
  //
  // Maybe this should not be here, we may want to apply a provisioning request to several things. Assembly, fileset
  //
  private ProvisioModel runtimeAssembly;
  private Map<String, String> versionMap;
  
  public File getOutputDirectory() {
    return outputDirectory;
  }

  public ProvisioningRequest setOutputDirectory(File outputDirectory) {
    if (outputDirectory == null) {
      this.outputDirectory = new File("").getAbsoluteFile();
    } else {
      this.outputDirectory = outputDirectory.getAbsoluteFile();
    }
    return this;
  }

  public RepositorySystem getRepositorySystem() {
    return repositorySystem;
  }

  public void setRepositorySystem(RepositorySystem repositorySystem) {
    this.repositorySystem = repositorySystem;
  }

  public RepositorySystemSession getResolutionSession() {
    return repositorySystemSession;
  }

  public void setResolutionSession(RepositorySystemSession resolutionSession) {
    this.repositorySystemSession = resolutionSession;
  }

  public String getLocalRepository() {
    return localRepository;
  }

  public void setLocalRepository(String localRepository) {
    this.localRepository = localRepository;
  }

  public List<RemoteRepository> getRemoteRepositories() {
    return remoteRepositories;
  }

  public void setRemoteRepositories(List<RemoteRepository> remoteRepositories) {
    this.remoteRepositories = remoteRepositories;
  }

  public ProvisioModel getRuntimeAssembly() {
    return runtimeAssembly;
  }

  public ProvisioningRequest setRuntimeAssembly(ProvisioModel runtimeAssembly) {
    this.runtimeAssembly = runtimeAssembly;
    return this;
  }
  
  //
  // VersionMap
  //
  public Map<String, String> getVersionMap() {
    return versionMap;
  }

  public ProvisioningRequest setVersionMap(Map<String, String> versionMap) {
    this.versionMap = versionMap;
    return this;
  }
  
  public void addVersionMap(Map<String, String> versionMap) {
    this.versionMap = versionMap;
  }  
}
